commit d436a267454a7fa1f5e78795285e762f3ddf56b6
Author: George Pantazis <gpant@noc.grnet.gr>
Date:   Thu Jun 21 17:35:46 2012 +0300

    Updated registration for restart manager to push null for app params (c++ dll import needs update for win8)
    Updated inno installer configuration for RM handling to include gpant commits.
    Added logging for RM registration (fails silently on anything before VISTA)
    
    Signed-off-by: George Pantazis <gpant@noc.grnet.gr>

diff --git a/trunk/Pithos.Installer/PithosPlus.~is b/trunk/Pithos.Installer/PithosPlus.~is
index eaeb87b..ea8d032 100644
--- a/trunk/Pithos.Installer/PithosPlus.~is
+++ b/trunk/Pithos.Installer/PithosPlus.~is
@@ -54,9 +54,11 @@ UninstallLogMode=append
 VersionInfoCompany=GRNET
 VersionInfoDescription=Pithos Plus
 VersionInfoCopyright=(c) 2011-2012 GRNET
-VersionInfoProductName=Pitho Plus
+VersionInfoProductName=Pithos Plus
 VersionInfoProductVersion=1
 AppModifyPath="{app}\UninsHs.exe" /m0=AppId
+;CloseApplications=yes
+RestartApplications=yes
 
 [Languages]
 Name: "english"; MessagesFile: "compiler:Default.isl"
@@ -79,12 +81,12 @@ Name: "quicklaunchicon"; Description: "{cm:CreateQuickLaunchIcon}"; GroupDescrip
 Source: "..\Pithos.Client.WPF\bin\Debug\PithosPlus.exe"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 Source: "..\Pithos.Client.WPF\bin\Debug\PithosPlus.exe.config"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 ; Appearance
-Source: "Skin\ISSkin.dll"; DestDir: {app}; Flags: dontcopy
-Source: "Skin\GRNETWhite.cjstyles"; DestDir: {tmp}; Flags: dontcopy
+;Source: "Skin\ISSkin.dll"; DestDir: {app}; Flags: dontcopy
+;Source: "Skin\GRNETWhite.cjstyles"; DestDir: {tmp}; Flags: dontcopy
 ; Repair/Modify
 Source: "Tools\UninsHs.exe"; DestDir: {app}; Flags: restartreplace
 ; Running Processes
-Source: "Tools\IssProc.dll"; DestDir: {app}; Flags: restartreplace
+;Source: "Tools\IssProc.dll"; DestDir: {app}; Flags: restartreplace
 ; DLL
 Source: "..\Pithos.ShellExtensions\bin\x86\Debug\Pithos.ShellExtensions.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek; Check: not Is64BitInstallMode
 Source: "..\Pithos.ShellExtensions\bin\x64\Debug\Pithos.ShellExtensions.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek; Check: Is64BitInstallMode
@@ -100,7 +102,6 @@ Source: "..\Pithos.Client.WPF\bin\Debug\log4net.dll"; DestDir: {app}; Flags: res
 Source: "..\Pithos.Client.WPF\bin\Debug\Newtonsoft.Json.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 Source: "..\Pithos.Client.WPF\bin\Debug\NHibernate.ByteCode.Castle.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 Source: "..\Pithos.Client.WPF\bin\Debug\NHibernate.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
-Source: "..\Pithos.Client.WPF\bin\Debug\NHibernate.Search.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 Source: "..\Pithos.Client.WPF\bin\Debug\ParallelExtensionsExtras.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 Source: "..\Pithos.Client.WPF\bin\Debug\Pithos.Core.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
 Source: "..\Pithos.Client.WPF\bin\Debug\Pithos.Interfaces.dll"; DestDir: {app}; Flags: restartreplace ignoreversion; Components: RequiredFiles; Languages: english french german spanish greek
@@ -314,34 +315,34 @@ dotNET40Missing: Boolean;
         LicenseID: Integer;      
 
 // IssFindModule called on in/uninstall
-function IssFindModule(hWnd: Integer; Modulename: String; Language: PAnsiChar; Silent: Boolean; CanIgnore: Boolean ): Integer;
-external 'IssFindModuleW@files:IssProc.dll stdcall setuponly';
+///function IssFindModule(hWnd: Integer; Modulename: String; Language: PAnsiChar; Silent: Boolean; CanIgnore: Boolean ): Integer;
+///external 'IssFindModuleW@files:IssProc.dll stdcall setuponly';
 
-function IssFindModuleU(hWnd: Integer; Modulename: String; Language: PAnsiChar; Silent: Boolean; CanIgnore: Boolean ): Integer;
-external 'IssFindModuleW@{app}\IssProc.dll stdcall uninstallonly';
+///function IssFindModuleU(hWnd: Integer; Modulename: String; Language: PAnsiChar; Silent: Boolean; CanIgnore: Boolean ): Integer;
+///external 'IssFindModuleW@{app}\IssProc.dll stdcall uninstallonly';
 
 //Call this to enable search for any in use file type
-function IssEnableAnyFileInUseCheck(Folder: String): Integer;
-external 'IssEnableAnyFileInUseCheckW@files:IssProc.dll stdcall setuponly';
+///function IssEnableAnyFileInUseCheck(Folder: String): Integer;
+///external 'IssEnableAnyFileInUseCheckW@files:IssProc.dll stdcall setuponly';
 
 //IssEnableAnyFileInUseCheck called on uninstall
-function IssEnableAnyFileInUseCheckU(Folder: String): Integer;
-external 'IssEnableAnyFileInUseCheckW@{app}\IssProc.dll stdcall uninstallonly';
+///function IssEnableAnyFileInUseCheckU(Folder: String): Integer;
+///external 'IssEnableAnyFileInUseCheckW@{app}\IssProc.dll stdcall uninstallonly';
 
 //Register for commercial use on install
-function IssRegister(rName: PAnsiChar; rKey: PAnsiChar): Integer;
-external 'IssRegister@files:IssProc.dll stdcall setuponly';
+///function IssRegister(rName: PAnsiChar; rKey: PAnsiChar): Integer;
+///external 'IssRegister@files:IssProc.dll stdcall setuponly';
 
 //Register for commercial use on uninstall
-function IssRegisterU(rName: PAnsiChar; rKey: PAnsiChar): Integer;
-external 'IssRegister@{app}\IssProc.dll stdcall uninstallonly';
+///function IssRegisterU(rName: PAnsiChar; rKey: PAnsiChar): Integer;
+///external 'IssRegister@{app}\IssProc.dll stdcall uninstallonly';
 
 // Importing LoadSkin API from ISSkin.DLL
-procedure LoadSkin(lpszPath: String; lpszIniFileName: String);
-external 'LoadSkin@files:isskin.dll stdcall';
+//procedure LoadSkin(lpszPath: String; lpszIniFileName: String);
+//external 'LoadSkin@files:isskin.dll stdcall';
 
-procedure UnloadSkin();
-external 'UnloadSkin@files:isskin.dll stdcall';
+//procedure UnloadSkin();
+//external 'UnloadSkin@files:isskin.dll stdcall';
 
 // Importing ShowWindow Windows API from User32.DLL
 function ShowWindow(hWnd: Integer; uType: Integer): Integer;
@@ -393,9 +394,9 @@ begin
       Result := false;
             
       hWnd := StrToInt(ExpandConstant('{wizardhwnd}'));                     { get main wizard handle }
-      IssEnableAnyFileInUseCheck(ExpandConstant('{app}'));
-      sModuleName :=ExpandConstant('pithos*.dll;PithosPlus.exe');            
-      nCode:=IssFindModule(hWnd,sModuleName,'en',false,true);                { search for module and display files-in-use window if found  }
+///      IssEnableAnyFileInUseCheck(ExpandConstant('{app}'));
+///      sModuleName :=ExpandConstant('pithos*.dll;PithosPlus.exe');            
+///      nCode:=IssFindModule(hWnd,sModuleName,'en',false,true);                { search for module and display files-in-use window if found  }
      if nCode=1 then  begin                                                 { cancel pressed or files-in-use window closed }
           PostMessage (WizardForm.Handle, $0010, 0, 0);                     { quit setup, $0010=WM_CLOSE }
      end else if (nCode=0) or (nCode=2) then begin                          { no module found or ignored pressed}
@@ -407,8 +408,8 @@ end;
 function InitializeSetup(): Boolean;
 begin
   //Unpack The Skin
-  ExtractTemporaryFile('GRNETWhite.cjstyles');
-  LoadSkin(ExpandConstant('{tmp}\GRNETWhite.cjstyles'), '');
+ //ExtractTemporaryFile('GRNETWhite.cjstyles');
+ //LoadSkin(ExpandConstant('{tmp}\GRNETWhite.cjstyles'), '');
     
   // Test the presence of .NET 4.0
   if (not(RegKeyExists(HKLM, 'SOFTWARE\Microsoft\NET Framework Setup\NDP\v4'))) then
@@ -420,8 +421,8 @@ end;
 procedure DeinitializeSetup();
 begin
   //Hide Window widget
-  ShowWindow(StrToInt(ExpandConstant('{wizardhwnd}')), 0);
-  UnloadSkin();
+  //ShowWindow(StrToInt(ExpandConstant('{wizardhwnd}')), 0);
+  //UnloadSkin();
 end;
 
 function ShouldInstalldotNET40(): Boolean;
@@ -534,10 +535,9 @@ begin
   BitmapImage1.width := Page.SurfaceWidth;
   BitmapImage1.height := Page.SurfaceHeight;
   BitmapImage1.Bitmap.LoadFromFile(BitmapFileName);
-  BitmapImage1.Left := 0 
+  BitmapImage1.Left := 0;
   BitmapImage1.Top := Page.Surface.Top + LabelWz.Height;
   BitmapImage1.Parent := Page.Surface;
-  
 end;
 
 procedure InitializeWizard;